<?php

require_once dirname(__FILE__).'/../lib/cadenceGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/cadenceGeneratorHelper.class.php';

/**
 * cadence actions.
 *
 * @package    sam3
 * @subpackage cadence
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class cadenceActions extends autoCadenceActions
{

    public function executeIndex(sfWebRequest $request)
    {
        $this->forward404();
    }

    public function executeSkasuj(sfWebRequest $request)
    {
        $request->checkCSRFProtection();

        $this->dispatcher->notify(new sfEvent($this, 'admin.delete_object', array('object' => $this->getRoute()->getObject())));

        $this->getRoute()->getObject()->delete();

        $this->getUser()->setFlash('notice', 'The item was deleted successfully.');

        $this->redirect('@session');
    }

    protected function processForm(sfWebRequest $request, sfForm $form)
    {
        $params = $request->getParameter($form->getName());
        if(!array_key_exists('order', $params))
            $params['order'] = CadencePeer::getMaxOrdering() + 1;

        $form->bind($params, $request->getFiles($form->getName()));
        if($form->isValid())
        {
            $notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';

            $cadence = $form->save();

            $this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $cadence)));

            if($request->hasParameter('_save_and_add'))
            {
                $this->getUser()->setFlash('notice', $notice.' You can add another one below.');

                $this->redirect('@cadence_new');
            }
            else
            {
                $this->getUser()->setFlash('notice', $notice);

                $this->redirect(array('sf_route' => 'cadence_edit', 'sf_subject' => $cadence));
            }
        }
        else
        {
            $this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
        }
    }

}