<?php

require_once dirname(__FILE__) . '/../lib/cadence_session_attachmentGeneratorConfiguration.class.php';
require_once dirname(__FILE__) . '/../lib/cadence_session_attachmentGeneratorHelper.class.php';

/**
 * cadence_session_attachment actions.
 *
 * @package    sam3
 * @subpackage cadence_session_attachment
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class cadence_session_attachmentActions extends autoCadence_session_attachmentActions {

    public function executeIndex(sfWebRequest $request) {
        $this->setLayout('default');
        $session_id = $request->getParameter('seso');
        $this->session_id = $session_id;
        $session = SessionPeer::retrieveByPK($session_id);
        $this->forward404Unless($session);

        $issue_list = $session->getIssueList();
        $this->issue_list = $issue_list;
        $this->form = new sessionUploadForm(array(), array('issue_list' => $issue_list));
        $this->form->setDefault('obj_id', $session_id);

        $this->zalaczniki = SessionAttachmentPeer::getSessionAttachments($session_id);

        if ($request->isMethod('post')) {
            $obj_id = $request->getParameter('file[obj_id]');
            $params = $request->getParameter('file');
            //devdump($params, '', 1);

            $this->form->bind($params, $request->getFiles('file'));

            if ($this->form->isValid()) {
                $user = $this->getUser();
                $values = $this->form->getValues();
                $file = $values['file_src'];

                $filename = sha1($file->getOriginalName());
                $extension = $file->getOriginalExtension();
                $zalacznik = new Zalacznik();
                $zalacznik->setNazwa($values['file_name']);
                $zalacznik->setNazwaPliku($filename . $extension);
                $zalacznik->setSciezka('/temp/sesje/sesja_' . $values['obj_id'] . '/attachments/');
                $zalacznik->setOpis($values['file_desc']);
                $zalacznik->setRozmiarPliku($file->getSize());
                $zalacznik->save();

                $zalacznik_seso = new SessionAttachment();
                $zalacznik_seso->setZalacznikId($zalacznik->getId());
                $zalacznik_seso->setSessionId($values['obj_id']);
                $zalacznik_seso->setIssueNumber($values['issue_id']);
                $zalacznik_seso->setOrder(SessionAttachmentPeer::getMaxOrdering($session_id) + 1);
                $zalacznik_seso->save();


                $file->save(sfConfig::get('sf_upload_dir') . '/temp/sesje/sesja_' . $values['obj_id'] . '/attachments/' . $filename . $extension);
                LogPeer::wstawLoga($user->getId(), 'seso', 'Dodanie załącznika: ' . $zalacznik->getNazwa(), 'Sesja', $obj_id);
                $this->redirect('cadence_session_attachment/index?seso=' . $values['obj_id']);
            }

            $this->zalaczniki = SessionAttachmentPeer::getSessionAttachments($session_id);
        }
    }

    public function executeChangeOrder(sfWebRequest $request) {
        $zal1_id = $request->getParameter('zal1');
        $zal2_id = $request->getParameter('zal2');
        $session_id = $request->getParameter('seso');
        if (isset($zal1_id) && isset($zal2_id) && isset($session_id)) {
            $user = $this->getUser();
            $zal1 = SessionAttachmentPeer::retrieveByPK($zal1_id);
            $zal2 = SessionAttachmentPeer::retrieveByPK($zal2_id);
            $zal1->zamienKolejnosc($zal2);
            LogPeer::wstawLoga($user->getId(), 'seso', 'Zmiana kolejnosci załączników: ' . $zal1->getZalacznik()->getNazwa() . ' <-> ' . $zal2->getZalacznik()->getNazwa(), 'Sesja', $session_id);
        }

        /* usuwam zalaczniki ktore byly spakowane do pobrania */
        $mask = sfConfig::get('sf_upload_dir') . '/temp/sesje/sesja_' . $session_id . '/attachments/*_zalaczniki.zip';
        array_map("unlink", glob($mask));

        $this->redirect('cadence_session_attachment/index?seso=' . $session_id);
    }

    public function executeSortZalaczniki() {
        $order = $this->getRequestParameter('order');
        $session_id = $this->getRequestParameter('seso');
        $flag = SessionAttachmentPeer::doSortZalaczniki($order);

         /* usuwam zalaczniki ktore byly spakowane do pobrania */
        $mask = sfConfig::get('sf_upload_dir') . '/temp/sesje/sesja_' . $session_id . '/attachments/*_zalaczniki.zip';
        array_map("unlink", glob($mask));
        
        return $flag ? sfView::SUCCESS : sfView::ERROR;
    }

    public function executeSetVisible(sfWebRequest $request) {
        $zal_id = $request->getParameter('zal');
        $action = $request->getParameter('op');
        $session_id = $request->getParameter('seso');
        if (isset($zal_id) && isset($action) && isset($session_id)) {
            $user = $this->getUser();
            $zal = SessionAttachmentPeer::retrieveByPK($zal_id);
            if ($action == 'show') {
                $zal->setZalacznikWidoczny(1);
            } else if ($action == 'hide') {
                $zal->setZalacznikWidoczny(0);
            }
            $zal->save();
        }

        /* usuwam zalaczniki ktore byly spakowane do pobrania */
        $mask = sfConfig::get('sf_upload_dir') . '/temp/sesje/sesja_' . $session_id . '/attachments/*_zalaczniki.zip';
        array_map("unlink", glob($mask));

        $this->redirect('cadence_session_attachment/index?seso=' . $session_id);
    }

    public function executeDelete(sfWebRequest $request) {
        $request->checkCSRFProtection();
        $zal_id = $request->getParameter('zal');
        $session_id = $request->getParameter('seso');

        if (isset($zal_id)) {
            $user = $this->getUser();
            $zalacznik = ZalacznikPeer::retrieveByPK($zal_id);

            if ($zalacznik)
                $zalacznik = $zalacznik->getZalacznik();

            if (!empty($zalacznik)) {
                $file = sfConfig::get('sf_upload_dir') . '/' . $zalacznik->getSciezka() . $zalacznik->getNazwaPliku();

                if (is_file($file))
                    unlink($file);

                LogPeer::wstawLoga($user->getId(), 'seso', 'Usunięcie załącznika: ' . $zalacznik->getNazwa(), 'Sesja', $session_id);

                /* usuwam zalaczniki ktore byly spakowane do pobrania */
                $mask = sfConfig::get('sf_upload_dir') . '/temp/sesje/sesja_' . $session_id . '/attachments/*_zalaczniki.zip';
                array_map("unlink", glob($mask));

                $zalacznik->delete();
            } else
                $this->redirect('cadence_session_attachment/index?seso=' . $session_id);
        }
        $this->getUser()->setFlash('notice', 'The item was deleted successfully.');

        $this->redirect('cadence_session_attachment/index?seso=' . $session_id);
    }

    public function prepareDownload($outFilename, $ext) {
        header('Content-Type: application/' . $ext . ';charset=UTF-8');
        header('Content-Disposition: attachment;filename=' . $outFilename);
        error_reporting(1);
        return sfView::HEADER_ONLY;
    }

    public function executeDownload(sfWebRequest $request) {
        $session_id = $request->getParameter('seso');
        $file_id = $request->getParameter('file_id');

        $zalacznik = SessionAttachmentPeer::retrieveByPK($file_id);
        $zalacznik_src = $zalacznik->getZalacznik();
        $file_src = $zalacznik_src->getNazwaPliku();
        $file_name = explode('.', $file_src);
        $ext = array_pop($file_name);
        $nazwa = trim($zalacznik_src->getNazwa());
        $file_name = explode(' ', $nazwa);
        $file_name = implode('_', $file_name);
        $this->prepareDownload($file_name . '.' . $ext, $ext);
        readfile(sfConfig::get('sf_upload_dir') . '/temp/sesje/sesja_' . $zalacznik->getSessionId() . '/attachments/' . $file_src);
        exit();
    }

}
