<?php

require_once dirname(__FILE__).'/../lib/cadence_structureGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/cadence_structureGeneratorHelper.class.php';

/**
 * cadence_structure actions.
 *
 * @package    sam3
 * @subpackage cadence_structure
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class cadence_structureActions extends autoCadence_structureActions
{

    public function executeIndex(sfWebRequest $request)
    {
        $this->forward404();
    }

    public function executeNew(sfWebRequest $request)
    {
        $this->form = $this->configuration->getForm();
        
        $cadence_id = $request->getParameter('cadence_id', null);
        if(!empty($cadence_id))
            $this->form->setDefault('cadence_id', $cadence_id);
        
        $parent_id = $request->getParameter('parent_id', null);
        if(!empty($parent_id))
            $this->form->setDefault('parent_id', $parent_id);
        
        $this->cadence_structure = $this->form->getObject();
    }

    public function executeSkasuj(sfWebRequest $request)
    {
        $request->checkCSRFProtection();

        $this->dispatcher->notify(new sfEvent($this, 'admin.delete_object', array('object' => $this->getRoute()->getObject())));

        $this->getRoute()->getObject()->delete();

        $this->getUser()->setFlash('notice', 'The item was deleted successfully.');

        $this->redirect('@session');
    }

    protected function processForm(sfWebRequest $request, sfForm $form)
    {
        $params = $request->getParameter($form->getName());        
        if(!array_key_exists('order', $params))
            $params['order'] = SessionPeer::getMaxOrdering($params['cadence_id'], $params['parent_id']) + 1;
        
        $form->bind($params, $request->getFiles($form->getName()));
        if($form->isValid())
        {
            $notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';

            $cadence_structure = $form->save();

            $this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $cadence_structure)));

            if($request->hasParameter('_save_and_add'))
            {
                $this->getUser()->setFlash('notice', $notice.' You can add another one below.');

                $this->redirect('@cadence_structure_new');
            }
            else
            {
                $this->getUser()->setFlash('notice', $notice);

                $this->redirect(array('sf_route' => 'cadence_structure_edit', 'sf_subject' => $cadence_structure));
            }
        }
        else
        {
            $this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
        }
    }

}