<?php

/**
 * sesje_obrad actions.
 *
 * @package    sam3
 * @subpackage sesje_obrad
 * @author     Your name here
 */
class sesje_obradActions extends sfActions
{
    public function preExecute()
    {
        $this->forward404Unless(in_array('seso', ModulPeer::getEnabled()));
    }
    
    public function executeIndex(sfWebRequest $request)
    {
        $cadence_id = $request->getParameter('cadence_id', null);
        $parent_id = $request->getParameter('parent_id', null);
        $position_id = $request->getParameter('position_id', null);
        $page = $request->getParameter('page', 1);
        
        $this->baseurl = 'sesje_obrad/index?';
        if($cadence_id)
            $this->baseurl .= 'cadence_id='.$cadence_id.'&';
        if($parent_id)
            $this->baseurl .= 'parent_id='.$parent_id.'&';
        if($position_id)
            $this->baseurl .= 'position_id='.$position_id.'&';
        
        $this->pager = SessionPubPeer::getSessionsPager($cadence_id, $parent_id, $position_id, $page);
        $this->pager->init();
        
    }

    public function executeShow(sfWebRequest $request)
    {
        $this->session = SessionPubPeer::retrieveByPK($request->getParameter('id'));
        $this->forward404Unless($this->session);
        $this->zalaczniki = $this->session->getSessionPubAttachmentsJoinZalacznikPub();
    }
    
    public function executeAjaxSearch(sfWebRequest $request)
    {
        $this->setLayout(false);
        
        $selected_session_id = $request->getParameter('session_selector');
        if(empty($selected_session_id))
            $this->redirect('sesje_obrad/index');
        
        if($selected_session_id)
            $this->redirect('sesje_obrad/show?id='.$selected_session_id);
        else
            $this->forward404('Nie ma takiego artykułu - '.$selected_session_id);
    }

    public function prepareDownload($outFilename, $ext)
    {
        header('Content-Type: application/'.$ext.';charset=UTF-8');
        header('Content-Disposition: attachment;filename='.$outFilename);
        error_reporting(1);
        return sfView::HEADER_ONLY;
    }

    public function executeDownload(sfWebRequest $request)
    {
        $session_id = $request->getParameter('session_id');   
        $file_id = $request->getParameter('file_id');

        $zalacznik = SessionPubAttachmentPeer::retrieveByPK($file_id);
        
        $this->forward404Unless($zalacznik && $zalacznik->getSessionId() == $session_id);
        
        $zalacznik->increaseDownloads();
        
        $zalacznik_src = $zalacznik->getZalacznikPub();
        $file_src = $zalacznik_src->getNazwaPliku();
        $file_name = explode('.', $file_src);
        $ext = array_pop($file_name);
        $nazwa = trim($zalacznik_src->getNazwa());
        $file_name = explode(' ', $nazwa);
        $file_name = implode('_', $file_name);
        $this->prepareDownload($file_name.'.'.$ext, $ext);
        readfile(sfConfig::get('sf_upload_dir').'/pub/sesje/sesja_'.$session_id.'/attachments/'.$file_src);
        exit();
    }
    
        public function executeDownloadZip(sfWebRequest $request)
    {

        $id = $request->getParameter('id');
        $c_zalaczniki = new Criteria();

        if($request->hasParameter('preview'))
        {
            $dokument = SessionPeer::retrieveByPK($id);
            $c_zalaczniki->add(SessionAttachmentPeer::SESSION_ID, $id);
            $c_zalaczniki->addAscendingOrderByColumn(SessionAttachmentPeer::ORDER);
            $zalaczniki_list = $dokument->getSessionAttachmentsJoinZalacznik($c_zalaczniki);
            $file_path = sfConfig::get('sf_upload_dir').'/temp/sesje/sesja_'.$id.'/attachments/';
        }
        else
        {
            $dokument = SessionPubPeer::retrieveByPK($id);
            $c_zalaczniki->add(SessionPubAttachmentPeer::SESSION_ID, $id);
            $c_zalaczniki->addAscendingOrderByColumn(SessionPubAttachmentPeer::ORDER);
            $zalaczniki_list = $dokument->getSessionPubAttachmentsJoinZalacznikPub($c_zalaczniki);
            $file_path = sfConfig::get('sf_upload_dir').'/pub/sesje/sesja_'.$id.'/attachments/';
        }
        $zipname = Functions::slugify($dokument->getTitle(), 255).'_zalaczniki.zip';

        if(!is_file($file_path.$zipname))
        {
            $zip = new ZipArchive;
            $zip->open($file_path.$zipname, ZipArchive::CREATE);
            foreach($zalaczniki_list as $file)
            {
                if($request->hasParameter('preview'))
                {
                    $zalacznik = $file->getZalacznik();
                }
                else
                {
                    $zalacznik = $file->getZalacznikPub();
                }
                $filename = $zalacznik->getNazwaPliku();
                $old_name = explode('.', $filename);
                $ext = ($old_name[1]);
                $nazwa = trim($zalacznik->getNazwa());
                $new_name = str_pad($file->getOrder(), 2, '0', STR_PAD_LEFT).'_'.Functions::slugify($nazwa, 255).'.'.$ext;

                $zip->addFile($file_path.$filename, pathinfo($new_name, PATHINFO_BASENAME));
            }
            $zip->close();
        }
        if(!$request->hasParameter('preview'))
        {
            foreach($zalaczniki_list as $file):
                $zalacznik = $file->getZalacznikPub();
                ZalacznikPeer::Pobran($zalacznik->getId());
            endforeach;
        }
        ///Then download the zipped file.
        ZalacznikPeer::prepareDownloadZip($zipname);
        readfile($file_path.$zipname);
        exit();
    }

}