<?php

/**
 * sesje_obrad actions.
 *
 * @package    sam3
 * @subpackage sesje_obrad
 * @author     Your name here
 */
class sesje_obradComponents extends sfComponents
{

    public function executeWyszukiwarka(sfWebRequest $request)
    {
        $module = $request->getParameter('module');
        $action = $request->getParameter('action');

        // wartosc domyslna pola wyszukiwarki
        $this->default = '';

        // przypadek gdy mamy konkretny obiekt sesji
        if($module == 'sesje_obrad' && $action == 'show')
        {
            $session = SessionPubPeer::retrieveByPK($request->getParameter('id', null));
            
            if($session)
            {
                $this->cadence = $session->getCadenceId();
                $this->position = $session->getStructPosId();                
                $this->parent = $session->getCadenceStructure()->getId();
                $this->session = $session->getId();
                $this->default = $session->getTitle();
            }
        }
        // przypadek gdy wyswietlamy liste 
        elseif($module == 'sesje_obrad' && $action == 'index')
        {
            $this->cadence = $request->getParameter('cadence_id', null);
            if($this->cadence)
            {
                $cadence = CadencePeer::retrieveByPK($this->cadence);
                $this->default = $cadence->getTitle();
            }
            
            $this->parent = $request->getParameter('parent_id', null);
            if($this->parent)
            {
                $parent = CadenceStructurePeer::retrieveByPK($this->parent);
                $this->cadence = $parent->getCadenceId();
                $this->default = $parent->getTitle();
            }
            
            $this->position = $request->getParameter('position_id', null);
            if($this->position)
            {
                $position = CadenceStructurePeer::retrieveByPK($this->position);
                $this->parent = $position->getParentId();
                $this->cadence = $position->getCadenceId();
                $this->default = $position->getTitle();
            }
            
            $this->session = null;
        }
        else
        // ogolny przypadek
        {
            $this->cadence = null;
            $this->parent = null;
            $this->position = null;
            $this->session = null;
        }

        list($this->cadences, $this->positions, $this->structure) = SessionPubPeer::getSessionSelectorChoices();
    }

    public function executeMenu(sfWebRequest $request)
    {
        $module = $request->getParameter('module');
        $action = $request->getParameter('action');

        // wartosc domyslna pola wyszukiwarki
        $this->default = '';

        // przypadek gdy mamy konkretny obiekt sesji
        if($module == 'sesje_obrad' && $action == 'show')
        {
            $session = SessionPubPeer::retrieveByPK($request->getParameter('id', null));
            
            if($session)
            {
                $this->cadence = $session->getCadenceId();
                $this->position = $session->getStructPosId();                
                $this->parent = $session->getCadenceStructure()->getParentId();
                $this->session = $session->getId();
                $this->default = $session->getTitle();
            }
        }
        // przypadek gdy wyswietlamy liste 
        elseif($module == 'sesje_obrad' && $action == 'index')
        {
            $this->cadence = $request->getParameter('cadence_id', null);
            if($this->cadence)
            {
                $cadence = CadencePeer::retrieveByPK($this->cadence);
                $this->default = $cadence->getTitle();
            }
            
            $this->parent = $request->getParameter('parent_id', null);
            if($this->parent)
            {
                $parent = CadenceStructurePeer::retrieveByPK($this->parent);
                $this->cadence = $parent->getCadenceId();
                $this->default = $parent->getTitle();
            }
            
            $this->position = $request->getParameter('position_id', null);
            if($this->position)
            {
                $position = CadenceStructurePeer::retrieveByPK($this->position);
                $this->parent = $position->getParentId();
                $this->cadence = $position->getCadenceId();
                $this->default = $position->getTitle();
            }
            
            $this->session = null;
        }
        else
        // ogolny przypadek
        {
            $this->cadence = null;
            $this->parent = null;
            $this->position = null;
            $this->session = null;
        }

        list($this->cadences, $this->positions, $this->structure) = SessionPubPeer::getSessionSelectorChoices();
    }

    public function executeNajnowsze(sfWebRequest $request)
    {
        if(!isset($this->limit))
            $this->limit = 5;
        
        $this->list = SessionPubPeer::getNewest($this->limit);
    }
}