<?php

require_once(sfConfig::get('sf_lib_dir').'/filter/base/BaseFormFilterPropel.class.php');

/**
 * SessionPubAttachment filter form base class.
 *
 * @package    sam3
 * @subpackage filter
 * @author     Your name here
 */
class BaseSessionPubAttachmentFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'session_id'          => new sfWidgetFormPropelChoice(array('model' => 'SessionPub', 'add_empty' => true)),
      'issue_number'        => new sfWidgetFormFilterInput(),
      'order'               => new sfWidgetFormFilterInput(),
      'zalacznik_id'        => new sfWidgetFormPropelChoice(array('model' => 'ZalacznikPub', 'add_empty' => true)),
      'zalacznik_kolejnosc' => new sfWidgetFormFilterInput(),
      'zalacznik_widoczny'  => new sfWidgetFormFilterInput(),
    ));

    $this->setValidators(array(
      'session_id'          => new sfValidatorPropelChoice(array('required' => false, 'model' => 'SessionPub', 'column' => 'id')),
      'issue_number'        => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'order'               => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'zalacznik_id'        => new sfValidatorPropelChoice(array('required' => false, 'model' => 'ZalacznikPub', 'column' => 'id')),
      'zalacznik_kolejnosc' => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'zalacznik_widoczny'  => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
    ));

    $this->widgetSchema->setNameFormat('session_pub_attachment_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'SessionPubAttachment';
  }

  public function getFields()
  {
    return array(
      'id'                  => 'Number',
      'session_id'          => 'ForeignKey',
      'issue_number'        => 'Number',
      'order'               => 'Number',
      'zalacznik_id'        => 'ForeignKey',
      'zalacznik_kolejnosc' => 'Number',
      'zalacznik_widoczny'  => 'Number',
    );
  }
}
