<?php

/**
 * Session form base class.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class BaseSessionForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'            => new sfWidgetFormInputHidden(),
      'order'         => new sfWidgetFormInput(),
      'cadence_id'    => new sfWidgetFormPropelChoice(array('model' => 'Cadence', 'add_empty' => false)),
      'struct_pos_id' => new sfWidgetFormPropelChoice(array('model' => 'CadenceStructure', 'add_empty' => false)),
      'session_date'  => new sfWidgetFormDateTime(),
      'title'         => new sfWidgetFormInput(),
      'description'   => new sfWidgetFormTextarea(),
      'created_at'    => new sfWidgetFormDateTime(),
      'updated_at'    => new sfWidgetFormDateTime(),
    ));

    $this->setValidators(array(
      'id'            => new sfValidatorPropelChoice(array('model' => 'Session', 'column' => 'id', 'required' => false)),
      'order'         => new sfValidatorInteger(array('required' => false)),
      'cadence_id'    => new sfValidatorPropelChoice(array('model' => 'Cadence', 'column' => 'id')),
      'struct_pos_id' => new sfValidatorPropelChoice(array('model' => 'CadenceStructure', 'column' => 'id')),
      'session_date'  => new sfValidatorDateTime(),
      'title'         => new sfValidatorString(array('max_length' => 255)),
      'description'   => new sfValidatorString(array('required' => false)),
      'created_at'    => new sfValidatorDateTime(array('required' => false)),
      'updated_at'    => new sfValidatorDateTime(array('required' => false)),
    ));

    $this->widgetSchema->setNameFormat('session[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Session';
  }


}
