<?php



class CadenceStructureMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.CadenceStructureMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(CadenceStructurePeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(CadenceStructurePeer::TABLE_NAME);
		$tMap->setPhpName('CadenceStructure');
		$tMap->setClassname('CadenceStructure');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, null);

		$tMap->addColumn('ORDER', 'Order', 'INTEGER', false, null);

		$tMap->addForeignKey('PARENT_ID', 'ParentId', 'INTEGER', 'cadence_structure', 'ID', false, null);

		$tMap->addForeignKey('CADENCE_ID', 'CadenceId', 'INTEGER', 'cadence', 'ID', true, null);

		$tMap->addColumn('TITLE', 'Title', 'VARCHAR', true, 255);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', false, null);

		$tMap->addColumn('UPDATED_AT', 'UpdatedAt', 'TIMESTAMP', false, null);

	} 
} 