<?php



class SessionAttachmentMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.SessionAttachmentMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(SessionAttachmentPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(SessionAttachmentPeer::TABLE_NAME);
		$tMap->setPhpName('SessionAttachment');
		$tMap->setClassname('SessionAttachment');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, null);

		$tMap->addForeignKey('SESSION_ID', 'SessionId', 'INTEGER', 'session', 'ID', true, null);

		$tMap->addColumn('ISSUE_NUMBER', 'IssueNumber', 'INTEGER', false, null);

		$tMap->addColumn('ORDER', 'Order', 'INTEGER', false, null);

		$tMap->addForeignKey('ZALACZNIK_ID', 'ZalacznikId', 'INTEGER', 'zalacznik', 'ID', true, null);

		$tMap->addColumn('ZALACZNIK_KOLEJNOSC', 'ZalacznikKolejnosc', 'INTEGER', true, 5);

		$tMap->addColumn('ZALACZNIK_WIDOCZNY', 'ZalacznikWidoczny', 'TINYINT', true, 1);

	} 
} 