<?php



class SessionPubAttachmentMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.SessionPubAttachmentMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(SessionPubAttachmentPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(SessionPubAttachmentPeer::TABLE_NAME);
		$tMap->setPhpName('SessionPubAttachment');
		$tMap->setClassname('SessionPubAttachment');

		$tMap->setUseIdGenerator(false);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, null);

		$tMap->addForeignKey('SESSION_ID', 'SessionId', 'INTEGER', 'session_pub', 'ID', true, null);

		$tMap->addColumn('ISSUE_NUMBER', 'IssueNumber', 'INTEGER', false, null);

		$tMap->addColumn('ORDER', 'Order', 'INTEGER', false, null);

		$tMap->addForeignKey('ZALACZNIK_ID', 'ZalacznikId', 'INTEGER', 'zalacznik_pub', 'ID', true, null);

		$tMap->addColumn('ZALACZNIK_KOLEJNOSC', 'ZalacznikKolejnosc', 'INTEGER', true, 5);

		$tMap->addColumn('ZALACZNIK_WIDOCZNY', 'ZalacznikWidoczny', 'TINYINT', true, 1);

	} 
} 