<?php



class SessionPubMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.SessionPubMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(SessionPubPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(SessionPubPeer::TABLE_NAME);
		$tMap->setPhpName('SessionPub');
		$tMap->setClassname('SessionPub');

		$tMap->setUseIdGenerator(false);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, null);

		$tMap->addColumn('ORDER', 'Order', 'INTEGER', false, null);

		$tMap->addForeignKey('CADENCE_ID', 'CadenceId', 'INTEGER', 'cadence', 'ID', true, null);

		$tMap->addForeignKey('STRUCT_POS_ID', 'StructPosId', 'INTEGER', 'cadence_structure', 'ID', true, null);

		$tMap->addColumn('SESSION_DATE', 'SessionDate', 'TIMESTAMP', true, null);

		$tMap->addColumn('TITLE', 'Title', 'VARCHAR', true, 255);

		$tMap->addColumn('DESCRIPTION', 'Description', 'LONGVARCHAR', false, null);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', false, null);

		$tMap->addColumn('UPDATED_AT', 'UpdatedAt', 'TIMESTAMP', false, null);

	} 
} 