<?php


abstract class BaseCadence extends BaseObject  implements Persistent {


  const PEER = 'CadencePeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $order;

	
	protected $title;

	
	protected $created_at;

	
	protected $updated_at;

	
	protected $collCadenceStructures;

	
	private $lastCadenceStructureCriteria = null;

	
	protected $collSessions;

	
	private $lastSessionCriteria = null;

	
	protected $collSessionPubs;

	
	private $lastSessionPubCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->order = 0;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getOrder()
	{
		return $this->order;
	}

	
	public function getTitle()
	{
		return $this->title;
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = CadencePeer::ID;
		}

		return $this;
	} 
	
	public function setOrder($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->order !== $v || $v === 0) {
			$this->order = $v;
			$this->modifiedColumns[] = CadencePeer::ORDER;
		}

		return $this;
	} 
	
	public function setTitle($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->title !== $v) {
			$this->title = $v;
			$this->modifiedColumns[] = CadencePeer::TITLE;
		}

		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = CadencePeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = CadencePeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(CadencePeer::ORDER))) {
				return false;
			}

			if ($this->order !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->order = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->title = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->created_at = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->updated_at = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 5; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Cadence object", $e);
		}
	}

	
	public function ensureConsistency()
	{

	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CadencePeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = CadencePeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->collCadenceStructures = null;
			$this->lastCadenceStructureCriteria = null;

			$this->collSessions = null;
			$this->lastSessionCriteria = null;

			$this->collSessionPubs = null;
			$this->lastSessionPubCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CadencePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			CadencePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isNew() && !$this->isColumnModified(CadencePeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(CadencePeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CadencePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			CadencePeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			if ($this->isNew() ) {
				$this->modifiedColumns[] = CadencePeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CadencePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += CadencePeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collCadenceStructures !== null) {
				foreach ($this->collCadenceStructures as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collSessions !== null) {
				foreach ($this->collSessions as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collSessionPubs !== null) {
				foreach ($this->collSessionPubs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = CadencePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collCadenceStructures !== null) {
					foreach ($this->collCadenceStructures as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collSessions !== null) {
					foreach ($this->collSessions as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collSessionPubs !== null) {
					foreach ($this->collSessionPubs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CadencePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getOrder();
				break;
			case 2:
				return $this->getTitle();
				break;
			case 3:
				return $this->getCreatedAt();
				break;
			case 4:
				return $this->getUpdatedAt();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = CadencePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getOrder(),
			$keys[2] => $this->getTitle(),
			$keys[3] => $this->getCreatedAt(),
			$keys[4] => $this->getUpdatedAt(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CadencePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setOrder($value);
				break;
			case 2:
				$this->setTitle($value);
				break;
			case 3:
				$this->setCreatedAt($value);
				break;
			case 4:
				$this->setUpdatedAt($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CadencePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setOrder($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setTitle($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setCreatedAt($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setUpdatedAt($arr[$keys[4]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CadencePeer::DATABASE_NAME);

		if ($this->isColumnModified(CadencePeer::ID)) $criteria->add(CadencePeer::ID, $this->id);
		if ($this->isColumnModified(CadencePeer::ORDER)) $criteria->add(CadencePeer::ORDER, $this->order);
		if ($this->isColumnModified(CadencePeer::TITLE)) $criteria->add(CadencePeer::TITLE, $this->title);
		if ($this->isColumnModified(CadencePeer::CREATED_AT)) $criteria->add(CadencePeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(CadencePeer::UPDATED_AT)) $criteria->add(CadencePeer::UPDATED_AT, $this->updated_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CadencePeer::DATABASE_NAME);

		$criteria->add(CadencePeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setOrder($this->order);

		$copyObj->setTitle($this->title);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getCadenceStructures() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addCadenceStructure($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getSessions() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addSession($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getSessionPubs() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addSessionPub($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CadencePeer();
		}
		return self::$peer;
	}

	
	public function clearCadenceStructures()
	{
		$this->collCadenceStructures = null; 	}

	
	public function initCadenceStructures()
	{
		$this->collCadenceStructures = array();
	}

	
	public function getCadenceStructures($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CadencePeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCadenceStructures === null) {
			if ($this->isNew()) {
			   $this->collCadenceStructures = array();
			} else {

				$criteria->add(CadenceStructurePeer::CADENCE_ID, $this->id);

				CadenceStructurePeer::addSelectColumns($criteria);
				$this->collCadenceStructures = CadenceStructurePeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CadenceStructurePeer::CADENCE_ID, $this->id);

				CadenceStructurePeer::addSelectColumns($criteria);
				if (!isset($this->lastCadenceStructureCriteria) || !$this->lastCadenceStructureCriteria->equals($criteria)) {
					$this->collCadenceStructures = CadenceStructurePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCadenceStructureCriteria = $criteria;
		return $this->collCadenceStructures;
	}

	
	public function countCadenceStructures(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CadencePeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collCadenceStructures === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(CadenceStructurePeer::CADENCE_ID, $this->id);

				$count = CadenceStructurePeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CadenceStructurePeer::CADENCE_ID, $this->id);

				if (!isset($this->lastCadenceStructureCriteria) || !$this->lastCadenceStructureCriteria->equals($criteria)) {
					$count = CadenceStructurePeer::doCount($criteria, $con);
				} else {
					$count = count($this->collCadenceStructures);
				}
			} else {
				$count = count($this->collCadenceStructures);
			}
		}
		return $count;
	}

	
	public function addCadenceStructure(CadenceStructure $l)
	{
		if ($this->collCadenceStructures === null) {
			$this->initCadenceStructures();
		}
		if (!in_array($l, $this->collCadenceStructures, true)) { 			array_push($this->collCadenceStructures, $l);
			$l->setCadence($this);
		}
	}


	
	public function getCadenceStructuresJoinCadenceStructureRelatedByParentId($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CadencePeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCadenceStructures === null) {
			if ($this->isNew()) {
				$this->collCadenceStructures = array();
			} else {

				$criteria->add(CadenceStructurePeer::CADENCE_ID, $this->id);

				$this->collCadenceStructures = CadenceStructurePeer::doSelectJoinCadenceStructureRelatedByParentId($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(CadenceStructurePeer::CADENCE_ID, $this->id);

			if (!isset($this->lastCadenceStructureCriteria) || !$this->lastCadenceStructureCriteria->equals($criteria)) {
				$this->collCadenceStructures = CadenceStructurePeer::doSelectJoinCadenceStructureRelatedByParentId($criteria, $con, $join_behavior);
			}
		}
		$this->lastCadenceStructureCriteria = $criteria;

		return $this->collCadenceStructures;
	}

	
	public function clearSessions()
	{
		$this->collSessions = null; 	}

	
	public function initSessions()
	{
		$this->collSessions = array();
	}

	
	public function getSessions($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CadencePeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSessions === null) {
			if ($this->isNew()) {
			   $this->collSessions = array();
			} else {

				$criteria->add(SessionPeer::CADENCE_ID, $this->id);

				SessionPeer::addSelectColumns($criteria);
				$this->collSessions = SessionPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(SessionPeer::CADENCE_ID, $this->id);

				SessionPeer::addSelectColumns($criteria);
				if (!isset($this->lastSessionCriteria) || !$this->lastSessionCriteria->equals($criteria)) {
					$this->collSessions = SessionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSessionCriteria = $criteria;
		return $this->collSessions;
	}

	
	public function countSessions(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CadencePeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collSessions === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(SessionPeer::CADENCE_ID, $this->id);

				$count = SessionPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(SessionPeer::CADENCE_ID, $this->id);

				if (!isset($this->lastSessionCriteria) || !$this->lastSessionCriteria->equals($criteria)) {
					$count = SessionPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collSessions);
				}
			} else {
				$count = count($this->collSessions);
			}
		}
		return $count;
	}

	
	public function addSession(Session $l)
	{
		if ($this->collSessions === null) {
			$this->initSessions();
		}
		if (!in_array($l, $this->collSessions, true)) { 			array_push($this->collSessions, $l);
			$l->setCadence($this);
		}
	}


	
	public function getSessionsJoinCadenceStructure($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CadencePeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSessions === null) {
			if ($this->isNew()) {
				$this->collSessions = array();
			} else {

				$criteria->add(SessionPeer::CADENCE_ID, $this->id);

				$this->collSessions = SessionPeer::doSelectJoinCadenceStructure($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(SessionPeer::CADENCE_ID, $this->id);

			if (!isset($this->lastSessionCriteria) || !$this->lastSessionCriteria->equals($criteria)) {
				$this->collSessions = SessionPeer::doSelectJoinCadenceStructure($criteria, $con, $join_behavior);
			}
		}
		$this->lastSessionCriteria = $criteria;

		return $this->collSessions;
	}

	
	public function clearSessionPubs()
	{
		$this->collSessionPubs = null; 	}

	
	public function initSessionPubs()
	{
		$this->collSessionPubs = array();
	}

	
	public function getSessionPubs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CadencePeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSessionPubs === null) {
			if ($this->isNew()) {
			   $this->collSessionPubs = array();
			} else {

				$criteria->add(SessionPubPeer::CADENCE_ID, $this->id);

				SessionPubPeer::addSelectColumns($criteria);
				$this->collSessionPubs = SessionPubPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(SessionPubPeer::CADENCE_ID, $this->id);

				SessionPubPeer::addSelectColumns($criteria);
				if (!isset($this->lastSessionPubCriteria) || !$this->lastSessionPubCriteria->equals($criteria)) {
					$this->collSessionPubs = SessionPubPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSessionPubCriteria = $criteria;
		return $this->collSessionPubs;
	}

	
	public function countSessionPubs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CadencePeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collSessionPubs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(SessionPubPeer::CADENCE_ID, $this->id);

				$count = SessionPubPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(SessionPubPeer::CADENCE_ID, $this->id);

				if (!isset($this->lastSessionPubCriteria) || !$this->lastSessionPubCriteria->equals($criteria)) {
					$count = SessionPubPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collSessionPubs);
				}
			} else {
				$count = count($this->collSessionPubs);
			}
		}
		return $count;
	}

	
	public function addSessionPub(SessionPub $l)
	{
		if ($this->collSessionPubs === null) {
			$this->initSessionPubs();
		}
		if (!in_array($l, $this->collSessionPubs, true)) { 			array_push($this->collSessionPubs, $l);
			$l->setCadence($this);
		}
	}


	
	public function getSessionPubsJoinCadenceStructure($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CadencePeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSessionPubs === null) {
			if ($this->isNew()) {
				$this->collSessionPubs = array();
			} else {

				$criteria->add(SessionPubPeer::CADENCE_ID, $this->id);

				$this->collSessionPubs = SessionPubPeer::doSelectJoinCadenceStructure($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(SessionPubPeer::CADENCE_ID, $this->id);

			if (!isset($this->lastSessionPubCriteria) || !$this->lastSessionPubCriteria->equals($criteria)) {
				$this->collSessionPubs = SessionPubPeer::doSelectJoinCadenceStructure($criteria, $con, $join_behavior);
			}
		}
		$this->lastSessionPubCriteria = $criteria;

		return $this->collSessionPubs;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collCadenceStructures) {
				foreach ((array) $this->collCadenceStructures as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collSessions) {
				foreach ((array) $this->collSessions as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collSessionPubs) {
				foreach ((array) $this->collSessionPubs as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collCadenceStructures = null;
		$this->collSessions = null;
		$this->collSessionPubs = null;
	}

} 