<?php


abstract class BaseSessionPubAttachment extends BaseObject  implements Persistent {


  const PEER = 'SessionPubAttachmentPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $session_id;

	
	protected $issue_number;

	
	protected $order;

	
	protected $zalacznik_id;

	
	protected $zalacznik_kolejnosc;

	
	protected $zalacznik_widoczny;

	
	protected $aSessionPub;

	
	protected $aZalacznikPub;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->issue_number = 0;
		$this->order = 0;
		$this->zalacznik_kolejnosc = 0;
		$this->zalacznik_widoczny = 1;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getSessionId()
	{
		return $this->session_id;
	}

	
	public function getIssueNumber()
	{
		return $this->issue_number;
	}

	
	public function getOrder()
	{
		return $this->order;
	}

	
	public function getZalacznikId()
	{
		return $this->zalacznik_id;
	}

	
	public function getZalacznikKolejnosc()
	{
		return $this->zalacznik_kolejnosc;
	}

	
	public function getZalacznikWidoczny()
	{
		return $this->zalacznik_widoczny;
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = SessionPubAttachmentPeer::ID;
		}

		return $this;
	} 
	
	public function setSessionId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->session_id !== $v) {
			$this->session_id = $v;
			$this->modifiedColumns[] = SessionPubAttachmentPeer::SESSION_ID;
		}

		if ($this->aSessionPub !== null && $this->aSessionPub->getId() !== $v) {
			$this->aSessionPub = null;
		}

		return $this;
	} 
	
	public function setIssueNumber($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->issue_number !== $v || $v === 0) {
			$this->issue_number = $v;
			$this->modifiedColumns[] = SessionPubAttachmentPeer::ISSUE_NUMBER;
		}

		return $this;
	} 
	
	public function setOrder($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->order !== $v || $v === 0) {
			$this->order = $v;
			$this->modifiedColumns[] = SessionPubAttachmentPeer::ORDER;
		}

		return $this;
	} 
	
	public function setZalacznikId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->zalacznik_id !== $v) {
			$this->zalacznik_id = $v;
			$this->modifiedColumns[] = SessionPubAttachmentPeer::ZALACZNIK_ID;
		}

		if ($this->aZalacznikPub !== null && $this->aZalacznikPub->getId() !== $v) {
			$this->aZalacznikPub = null;
		}

		return $this;
	} 
	
	public function setZalacznikKolejnosc($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->zalacznik_kolejnosc !== $v || $v === 0) {
			$this->zalacznik_kolejnosc = $v;
			$this->modifiedColumns[] = SessionPubAttachmentPeer::ZALACZNIK_KOLEJNOSC;
		}

		return $this;
	} 
	
	public function setZalacznikWidoczny($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->zalacznik_widoczny !== $v || $v === 1) {
			$this->zalacznik_widoczny = $v;
			$this->modifiedColumns[] = SessionPubAttachmentPeer::ZALACZNIK_WIDOCZNY;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(SessionPubAttachmentPeer::ISSUE_NUMBER,SessionPubAttachmentPeer::ORDER,SessionPubAttachmentPeer::ZALACZNIK_KOLEJNOSC,SessionPubAttachmentPeer::ZALACZNIK_WIDOCZNY))) {
				return false;
			}

			if ($this->issue_number !== 0) {
				return false;
			}

			if ($this->order !== 0) {
				return false;
			}

			if ($this->zalacznik_kolejnosc !== 0) {
				return false;
			}

			if ($this->zalacznik_widoczny !== 1) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->session_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->issue_number = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->order = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->zalacznik_id = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->zalacznik_kolejnosc = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->zalacznik_widoczny = ($row[$startcol + 6] !== null) ? (int) $row[$startcol + 6] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 7; 
		} catch (Exception $e) {
			throw new PropelException("Error populating SessionPubAttachment object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aSessionPub !== null && $this->session_id !== $this->aSessionPub->getId()) {
			$this->aSessionPub = null;
		}
		if ($this->aZalacznikPub !== null && $this->zalacznik_id !== $this->aZalacznikPub->getId()) {
			$this->aZalacznikPub = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SessionPubAttachmentPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = SessionPubAttachmentPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aSessionPub = null;
			$this->aZalacznikPub = null;
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SessionPubAttachmentPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			SessionPubAttachmentPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SessionPubAttachmentPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			SessionPubAttachmentPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aSessionPub !== null) {
				if ($this->aSessionPub->isModified() || $this->aSessionPub->isNew()) {
					$affectedRows += $this->aSessionPub->save($con);
				}
				$this->setSessionPub($this->aSessionPub);
			}

			if ($this->aZalacznikPub !== null) {
				if ($this->aZalacznikPub->isModified() || $this->aZalacznikPub->isNew()) {
					$affectedRows += $this->aZalacznikPub->save($con);
				}
				$this->setZalacznikPub($this->aZalacznikPub);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = SessionPubAttachmentPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += SessionPubAttachmentPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aSessionPub !== null) {
				if (!$this->aSessionPub->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aSessionPub->getValidationFailures());
				}
			}

			if ($this->aZalacznikPub !== null) {
				if (!$this->aZalacznikPub->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aZalacznikPub->getValidationFailures());
				}
			}


			if (($retval = SessionPubAttachmentPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SessionPubAttachmentPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getSessionId();
				break;
			case 2:
				return $this->getIssueNumber();
				break;
			case 3:
				return $this->getOrder();
				break;
			case 4:
				return $this->getZalacznikId();
				break;
			case 5:
				return $this->getZalacznikKolejnosc();
				break;
			case 6:
				return $this->getZalacznikWidoczny();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = SessionPubAttachmentPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getSessionId(),
			$keys[2] => $this->getIssueNumber(),
			$keys[3] => $this->getOrder(),
			$keys[4] => $this->getZalacznikId(),
			$keys[5] => $this->getZalacznikKolejnosc(),
			$keys[6] => $this->getZalacznikWidoczny(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SessionPubAttachmentPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setSessionId($value);
				break;
			case 2:
				$this->setIssueNumber($value);
				break;
			case 3:
				$this->setOrder($value);
				break;
			case 4:
				$this->setZalacznikId($value);
				break;
			case 5:
				$this->setZalacznikKolejnosc($value);
				break;
			case 6:
				$this->setZalacznikWidoczny($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SessionPubAttachmentPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setSessionId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setIssueNumber($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setOrder($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setZalacznikId($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setZalacznikKolejnosc($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setZalacznikWidoczny($arr[$keys[6]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(SessionPubAttachmentPeer::DATABASE_NAME);

		if ($this->isColumnModified(SessionPubAttachmentPeer::ID)) $criteria->add(SessionPubAttachmentPeer::ID, $this->id);
		if ($this->isColumnModified(SessionPubAttachmentPeer::SESSION_ID)) $criteria->add(SessionPubAttachmentPeer::SESSION_ID, $this->session_id);
		if ($this->isColumnModified(SessionPubAttachmentPeer::ISSUE_NUMBER)) $criteria->add(SessionPubAttachmentPeer::ISSUE_NUMBER, $this->issue_number);
		if ($this->isColumnModified(SessionPubAttachmentPeer::ORDER)) $criteria->add(SessionPubAttachmentPeer::ORDER, $this->order);
		if ($this->isColumnModified(SessionPubAttachmentPeer::ZALACZNIK_ID)) $criteria->add(SessionPubAttachmentPeer::ZALACZNIK_ID, $this->zalacznik_id);
		if ($this->isColumnModified(SessionPubAttachmentPeer::ZALACZNIK_KOLEJNOSC)) $criteria->add(SessionPubAttachmentPeer::ZALACZNIK_KOLEJNOSC, $this->zalacznik_kolejnosc);
		if ($this->isColumnModified(SessionPubAttachmentPeer::ZALACZNIK_WIDOCZNY)) $criteria->add(SessionPubAttachmentPeer::ZALACZNIK_WIDOCZNY, $this->zalacznik_widoczny);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(SessionPubAttachmentPeer::DATABASE_NAME);

		$criteria->add(SessionPubAttachmentPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setId($this->id);

		$copyObj->setSessionId($this->session_id);

		$copyObj->setIssueNumber($this->issue_number);

		$copyObj->setOrder($this->order);

		$copyObj->setZalacznikId($this->zalacznik_id);

		$copyObj->setZalacznikKolejnosc($this->zalacznik_kolejnosc);

		$copyObj->setZalacznikWidoczny($this->zalacznik_widoczny);


		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new SessionPubAttachmentPeer();
		}
		return self::$peer;
	}

	
	public function setSessionPub(SessionPub $v = null)
	{
		if ($v === null) {
			$this->setSessionId(NULL);
		} else {
			$this->setSessionId($v->getId());
		}

		$this->aSessionPub = $v;

						if ($v !== null) {
			$v->addSessionPubAttachment($this);
		}

		return $this;
	}


	
	public function getSessionPub(PropelPDO $con = null)
	{
		if ($this->aSessionPub === null && ($this->session_id !== null)) {
			$c = new Criteria(SessionPubPeer::DATABASE_NAME);
			$c->add(SessionPubPeer::ID, $this->session_id);
			$this->aSessionPub = SessionPubPeer::doSelectOne($c, $con);
			
		}
		return $this->aSessionPub;
	}

	
	public function setZalacznikPub(ZalacznikPub $v = null)
	{
		if ($v === null) {
			$this->setZalacznikId(NULL);
		} else {
			$this->setZalacznikId($v->getId());
		}

		$this->aZalacznikPub = $v;

						if ($v !== null) {
			$v->addSessionPubAttachment($this);
		}

		return $this;
	}


	
	public function getZalacznikPub(PropelPDO $con = null)
	{
		if ($this->aZalacznikPub === null && ($this->zalacznik_id !== null)) {
			$c = new Criteria(ZalacznikPubPeer::DATABASE_NAME);
			$c->add(ZalacznikPubPeer::ID, $this->zalacznik_id);
			$this->aZalacznikPub = ZalacznikPubPeer::doSelectOne($c, $con);
			
		}
		return $this->aZalacznikPub;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
			$this->aSessionPub = null;
			$this->aZalacznikPub = null;
	}

} 